/*
 * main.cc
 * Copyright (C) FSnow 2009-2010 <fsnow@yandex.ru>
 *
	main.cc is free software: you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the
	Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	main.cc is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	See the GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License along
	with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "main.h"

IMPLEMENT_APP(MyApp)

//**********************************************************************
//**********************************************************************
// методы класса приложения

//----------------------------------------------------------------------
// при запуске приложения
bool MyApp::OnInit()
{
	if ( !wxApp::OnInit() )
        return false;

	// локализация
	wxLocale *m_Locale = new wxLocale();
	m_Locale->Init();
	m_Locale->AddCatalog(wxT("fskbsetting"));

	// поиск base.xml
	if(wxFileExists(wxT("/etc/X11/xkb/base.xml")))	// если файл существует
		xmlBaseFile = wxT("/etc/X11/xkb/base.xml");
	else if(wxFileExists(wxT("/usr/share/X11/xkb/rules/base.xml")))
		xmlBaseFile = wxT("/usr/share/X11/xkb/rules/base.xml");
	else
	{
		wxPrintf(wxT("Error: File not found - base.xml\n"));
		wxMessageBox(_("Error: File base.xml was not found."), _("Error"), wxICON_ERROR);
		return false;
	}

	// создание окна
	MyFrame *frame = new MyFrame();
	frame->Show(true);

	return true;
}

//----------------------------------------------------------------------
// при закрытии приложения
int MyApp::OnExit()
{
	delete wxConfigBase::Set((wxConfigBase *) NULL);
	return 0;
}


