/*
 * myframe.cc
 * Copyright (C) FSnow 2009-2010 <fsnow@yandex.ru>
 *
	myframe.cc is free software: you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the
	Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	myframe.cc is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	See the GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License along
	with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "myframe.h"

//**********************************************************************
//**********************************************************************
// таблица событий
BEGIN_EVENT_TABLE(MyFrame, wxFrame)
    EVT_BUTTON(wxID_OK,  MyFrame::OnOK)
    EVT_BUTTON(wxID_EXIT, MyFrame::OnQuit)
	EVT_BUTTON(id_btnAbout, MyFrame::OnAbout)

	EVT_CHOICE(id_chLayout0, MyFrame::OnLayoutSelect)
	EVT_CHOICE(id_chLayout1, MyFrame::OnLayoutSelect)
	EVT_CHOICE(id_chLayout2, MyFrame::OnLayoutSelect)
	EVT_CHOICE(id_chLayout3, MyFrame::OnLayoutSelect)

	EVT_CHOICE(id_chVariant0, MyFrame::OnVariantSelect)
	EVT_CHOICE(id_chVariant1, MyFrame::OnVariantSelect)
	EVT_CHOICE(id_chVariant2, MyFrame::OnVariantSelect)
	EVT_CHOICE(id_chVariant3, MyFrame::OnVariantSelect)

	EVT_UPDATE_UI(id_chVariant0, MyFrame::OnUpdateUIchVariant)
	EVT_UPDATE_UI(id_chVariant1, MyFrame::OnUpdateUIchVariant)
	EVT_UPDATE_UI(id_chVariant2, MyFrame::OnUpdateUIchVariant)
	EVT_UPDATE_UI(id_chVariant3, MyFrame::OnUpdateUIchVariant)
	EVT_UPDATE_UI(wxID_OK, MyFrame::OnUpdateUIbtnOK)
END_EVENT_TABLE()

//**********************************************************************
//**********************************************************************
// конструкторы и методы классов

//----------------------------------------------------------------------
// конструктор главного окна
MyFrame::MyFrame() : wxFrame(NULL, wxID_ANY, _("Keyboard layouts"))
{
	SetIcon(wxICON(sample));								// устанавливаем иконку
	wxBoxSizer *bSizerMain = new wxBoxSizer( wxVERTICAL );	// создаем основной калибратор

	//------------------------------------------------------------------
	// Model - добавляем элементы управления для выбора модели клавы
	
	// создаем горизонтальный калибратор
	wxBoxSizer *hSizerModel = new wxBoxSizer( wxHORIZONTAL );
	
	// создаем надпись
	wxStaticText *stModel = new wxStaticText( this, wxID_ANY, _("Keyboard model:"), wxDefaultPosition, wxDefaultSize, 0 );
	stModel->SetFont( wxFont( wxNORMAL_FONT->GetPointSize(), 70, 90, 92, false, wxEmptyString ) );
	//добавляем ее к калибратору
	hSizerModel->Add( stModel, 0, wxALIGN_CENTER|wxALL, 2 );
	
	//создаем список моделей
	chModel = new wxChoice( this, id_chModel, wxDefaultPosition, wxDefaultSize);
	// добавляем список моделей к калибратору
	hSizerModel->Add( chModel, 1, wxALIGN_CENTER|wxALL, 2 );

	//создаем горизонтальную линию
	wxStaticLine *m_staticline1 = new wxStaticLine( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL );
	
	//------------------------------------------------------------------
	// layouts - добавляем элементы управления для выбора раскладок и их вариантов
	
	// создаем калибратор-таблицу, в ней будем размещать две подписи, списки раскладок и вариантов
	wxFlexGridSizer* fgSizer1 = new wxFlexGridSizer( 5, 2, 0, 0 );
	
	// создаем подпись для первой колонки
	wxStaticText *stLayouts = new wxStaticText( this, wxID_ANY, _("Layout:"));
	stLayouts->SetFont( wxFont( wxNORMAL_FONT->GetPointSize(), 70, 90, 92, false, wxEmptyString ) );
	// добавляем ее к калибратору-таблице
	fgSizer1->Add( stLayouts, 0, wxALL, 2 );
	
	// создаем подпись для второй колонки
	wxStaticText *stVariants = new wxStaticText( this, wxID_ANY, _("Variant:"));
	stVariants->SetFont( wxFont( wxNORMAL_FONT->GetPointSize(), 70, 90, 92, false, wxEmptyString ) );
	// добавляем ее к калибратору-таблице
	fgSizer1->Add( stVariants, 0, wxALL, 2 );
	
	wxSize size = wxSize(250,-1);// размер для списков вриантов, чтобы они были одинаковы
		
	// #0
	//создаем список раскладок
	chLayout[0] = new wxChoice( this, id_chLayout0, wxDefaultPosition, wxDefaultSize);
	// добавляем его к калибратору-таблице
	fgSizer1->Add( chLayout[0], 0, wxALL, 2 );
	
	//создаем список вариантов
	chVariant[0] = new wxChoice( this, id_chVariant0, wxDefaultPosition, wxDefaultSize);
	chVariant[0]->SetMinSize( size );
	// добавляем его к калибратору-таблице
	fgSizer1->Add( chVariant[0], 0, wxALL, 2 );
	
	// #1
	chLayout[1] = new wxChoice( this, id_chLayout1, wxDefaultPosition, wxDefaultSize);
	fgSizer1->Add( chLayout[1], 0, wxALL, 2 );
	
	chVariant[1] = new wxChoice( this, id_chVariant1, wxDefaultPosition, wxDefaultSize);
	chVariant[1]->SetMinSize( size );
	fgSizer1->Add( chVariant[1], 0, wxALL, 2 );

	// #2
	chLayout[2] = new wxChoice( this, id_chLayout2, wxDefaultPosition, wxDefaultSize);
	fgSizer1->Add( chLayout[2], 0, wxALL, 2 );
		
	chVariant[2] = new wxChoice( this, id_chVariant2, wxDefaultPosition, wxDefaultSize);
	chVariant[2]->SetMinSize( size );
	fgSizer1->Add( chVariant[2], 0, wxALL, 2 );

	// #3
	chLayout[3] = new wxChoice( this, id_chLayout3, wxDefaultPosition, wxDefaultSize);
	fgSizer1->Add( chLayout[3], 0, wxALL, 2 );
	
	chVariant[3] = new wxChoice( this, id_chVariant3, wxDefaultPosition, wxDefaultSize);
	chVariant[3]->SetMinSize( size );
	fgSizer1->Add( chVariant[3], 0, wxALL, 2 );

	//создаем горизонтальную линию
	wxStaticLine *m_staticline2 = new wxStaticLine( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL );
	
	//------------------------------------------------------------------
	// HotKeys - добавляем элементы управления для выбора хоткеев

	// создаем горизонтальный калибратор
	wxBoxSizer *hSizerHotKey = new wxBoxSizer( wxHORIZONTAL );

	// создаем надпись
	wxStaticText *stHotKey = new wxStaticText( this, wxID_ANY, _("Toggling mode:") );
	stHotKey->SetFont( wxFont( wxNORMAL_FONT->GetPointSize(), 70, 90, 92, false, wxEmptyString ) );
	//добавляем ее к калибратору
	hSizerHotKey->Add( stHotKey, 0, wxALIGN_CENTER|wxALL, 2 );

	//создаем список хоткеев
	chHotKey = new wxChoice( this, id_chHotKey, wxDefaultPosition, wxDefaultSize);
	// добавляем список хоткеев к калибратору
	hSizerHotKey->Add( chHotKey, 0, wxALIGN_CENTER|wxALL, 2 );

	//создаем горизонтальную линию
	wxStaticLine *m_staticline3 = new wxStaticLine( this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxLI_HORIZONTAL );

	//------------------------------------------------------------------
	// buttons & checkbox - создание кнопок и чекбокса

	// создаем горизонтальный калибратор
	wxBoxSizer *bSizerBtn = new wxBoxSizer( wxHORIZONTAL );

	// создаем кнопку О программе
	wxBitmap bmp1(wxArtProvider::GetBitmap(wxART_HELP));       
    wxBitmapButton *btnAbout = new wxBitmapButton(this, id_btnAbout, bmp1);
    btnAbout ->SetToolTip( _("About") );
	// добавляем ее к калибратору
	bSizerBtn->Add( btnAbout , 0, wxALL, 5 );

	bSizerBtn->Add( 0, 0, 1, wxEXPAND, 5 );

	// создаем чекбокс
	chkBoot = new wxCheckBox(this, id_chkBoot, _("Add to startup"));
	bSizerBtn->Add( chkBoot , 0, wxALIGN_CENTER_VERTICAL, 5 );

	bSizerBtn->Add( 0, 0, 1, wxEXPAND, 5 );
	
	// создаем кнопку ОК
	wxButton *btnOK = new wxButton( this, wxID_OK );
	// добавляем ее к калибратору
	bSizerBtn->Add( btnOK, 0, wxALL, 5 );

	// создаем кнопку Выход
	wxButton *btnEX = new wxButton( this, wxID_EXIT );
	// добавляем ее к калибратору
	bSizerBtn->Add( btnEX, 0, wxALL, 5 );

	//------------------------------------------------------------------
	// final - располагаем на форме все созданные элементы (калибраторы и линии)
	
	bSizerMain->Add( hSizerModel, 0, wxALIGN_CENTER|wxALL, 5 );
	bSizerMain->Add( m_staticline1, 0, wxEXPAND|wxALL, 5 );
	bSizerMain->Add( fgSizer1, 0, wxALIGN_CENTER|wxALL, 5 );
	bSizerMain->Add( m_staticline2, 0, wxEXPAND|wxALL, 5 );
	bSizerMain->Add( hSizerHotKey, 0, wxALIGN_CENTER|wxALL, 5 );
	bSizerMain->Add( m_staticline3, 0, wxEXPAND|wxALL, 5 );
	bSizerMain->Add( bSizerBtn, 0, wxEXPAND, 5 );

	// устанавливаем текущие значения элементов
	InitModels();
	InitLayouts();
	InitHotKeys();
	ReadConfig();
	
	// привязываем к окну главный калибратор
	// и подгоняем размеры окна
	this->SetSizer( bSizerMain );
	SetSize(DoGetBestSize());

}// MyFrame::MyFrame

//**********************************************************************
//**********************************************************************
// обработка событий

//----------------------------------------------------------------------
// по кнопке ок
void MyFrame::OnOK(wxCommandEvent& WXUNUSED(event))
{
	wxTextFile file;
	// формируем команду на основе выбранных параметров
	wxString MagicLine = wxT("setxkbmap");	// команда
	wxString Layout = wxT(" -layout \"");	// раскладки
	wxString Variant = wxT(" -variant \"");	// варианты
	wxString Model = wxEmptyString;			// модель клавы
	wxString Option = wxT(" -option -option \"");	// опции

	// задаем раскладки и варианты
	Layout += Layouts.Item(select_layout[0]);
	Variant += Variants[0].Item(select_variant[0]);

	if(select_layout[1]>0)
	{
		Layout += wxT(",")+Layouts.Item(select_layout[1]);
		Variant += wxT(",")+Variants[1].Item(select_variant[1]);
	}

	if(select_layout[2]>0)
	{
		Layout += wxT(",")+Layouts.Item(select_layout[2]);
		Variant += wxT(",")+Variants[2].Item(select_variant[2]);
	}

	if(select_layout[3]>0)
	{
		Layout += wxT(",")+Layouts.Item(select_layout[3]);
		Variant += wxT(",")+Variants[3].Item(select_variant[3]);
	}

	Layout += wxT("\"");
	Variant += wxT("\"");

	// задаем модель клавы
	int NSelectModels = chModel->GetCurrentSelection();	// получаем индекс выбранной модели клавы
	if(NSelectModels)									// если что-то выбрано, то добавляем
	{
		Model += wxT(" -model \"");
		Model += Models.Item(NSelectModels);			// добавляем к строке значение модели.
		Model += wxT("\"");
	}

	// задаем хоткеи
	int NSelectHotKey = chHotKey->GetCurrentSelection();// получаем индекс выбранного хоткея
	Option += HotKeys.Item(NSelectHotKey);				// добавляем к строке значение этого хоткея.
	Option += wxT("\"");

	//собираем строку
	MagicLine += Layout+Variant+Model+Option;
	
	// изменяем файлы автозагрузки
	if(chkBoot->IsChecked()) 
	{
		
		if(wxFileExists(file_autostart))	// если файл существует
		file.Open(file_autostart);	// то открываем его
	else						// если не существует
                if( !wxDirExists(homedir+wxT("/.config/autostart/")) ){
                    wxShell(wxT("mkdir -p ")+homedir+wxT("/.config/autostart/"));
                }

		file.Create(file_autostart);	// то создаем

		
		file.Clear(); //очищаем его
		file.InsertLine(wxT("[Desktop Entry]\nName=fsKBSet\nTerminal=false\nType=Application\nExec=")+MagicLine,0);
		file.Write();				// записываем изменения
		file.Close();
	}	    
	else
	{
		if(wxFileExists(file_autostart)){	// если файл существует
		file.Open(file_autostart);
		file.Clear(); //очищаем его
		file.Write(); // записываем изменения
		file.Close();
		}
    }
	// сохраняем конфигурацию
	wxConfigBase *pConfig = wxConfigBase::Get();
	if ( pConfig != NULL )
	{
		pConfig->Write(wxT("/Version"), wxT(VERSION));
		pConfig->Write(wxT("/Model"), chModel->GetSelection());
		pConfig->Write(wxT("/HotKey"), chHotKey->GetSelection());
		pConfig->Write(wxT("/Boot"), chkBoot->GetValue());

		pConfig->Write(wxT("/Layout0"), select_layout[0]);
		pConfig->Write(wxT("/Layout1"), select_layout[1]);
		pConfig->Write(wxT("/Layout2"), select_layout[2]);
		pConfig->Write(wxT("/Layout3"), select_layout[3]);

		pConfig->Write(wxT("/Variant0"), chVariant[0]->GetSelection());
		pConfig->Write(wxT("/Variant1"), chVariant[1]->GetSelection());
		pConfig->Write(wxT("/Variant2"), chVariant[2]->GetSelection());
		pConfig->Write(wxT("/Variant3"), chVariant[3]->GetSelection());
		wxPrintf(wxT("Saving configuration.\n"));
	}

	// выполняем команду
	wxPrintf(wxT("Runing command: %s\n"), MagicLine.c_str());
	wxShell(MagicLine);

	// перезапускаем lxpanel, если она есть в процессах
	wxArrayString pgrep;
	wxExecute(wxT("pgrep lxpanel"), pgrep, wxEXEC_SYNC);
	if(pgrep.Count()>0)
		wxShell(wxT("lxpanelctl restart"));
	
	wxPrintf(wxT("Exiting.\n"));
	Close(true);	// завершаем программу
	return;			// выходим из функции
} // OnOK

//----------------------------------------------------------------------
// по кнопке выход
void MyFrame::OnQuit(wxCommandEvent& WXUNUSED(event))
{
	wxPrintf(wxT("Exiting.\n"));
    Close(true);	// завершаем программу
} //OnQuit

//----------------------------------------------------------------------
// по кнопке справка
void MyFrame::OnAbout(wxCommandEvent& WXUNUSED(event))
{
	wxAboutDialogInfo info;
    info.SetIcon(wxICON(sample));
	info.SetName(wxT("fsKBSetting"));
    info.SetVersion( wxT(VERSION) );
    info.SetDescription(_("This is GUI frontend for setxkbmap command.\n"\
				"This tool is a C++ programm,\n"\
				"written using wxWidgets."));
    info.SetCopyright(wxT("(C) 2009-2010 FSnow"));
    info.AddDeveloper(wxT("FSnow\t<fsnow@yandex.ru>"));
	info.AddDeveloper(wxT("HsH\t\t<hsh@runtu.org>"));
	// translator name <email>
	info.AddTranslator(_("Konstantin Lavrov\t<klavrov@gmail.com>"));
	wxPrintf(wxT("Showing AboutBox\n"));
    wxAboutBox(info);
} // OnAbout

//----------------------------------------------------------------------
// при выборе раскладки
void MyFrame::OnLayoutSelect(wxCommandEvent& event)
{
	int N = event.GetId() - id_chLayout0; // N - индекс для выбора из массивов

	wxChoice *ch_layout = chLayout[N];	// указатель на список раскладок
	wxChoice *ch_variant = chVariant[N];// указатель на список вариантов

	int select = ch_layout->GetSelection(); // запоминаем что выбрал пользователь
	int prev_select = select_layout[N];		// запоминаем что было выбрано до этого

	select_layout[N] = select;			// обновляем массив с выбранными раскладками
	
	wxPrintf(wxT("Layout %d:%d selected\n"), N, select);

	// если выбрана новая раскладка, то подгружаем для нее список вариантов
	if (prev_select!=select) LoadVariants(N, select);
	
}// OnLayoutSelect()

//----------------------------------------------------------------------
// при выборе варианта
void MyFrame::OnVariantSelect(wxCommandEvent& event)
{
	int id = event.GetId();	// идентификатор списка вариантов
	int N = id - id_chVariant0; // индекс для выбора из массива
	wxChoice *ch_variant = chVariant[N];// указатель на список вариантов

	// обновляем массив выбранных раскладок
	select_variant[N] = ch_variant->GetSelection();
	
	wxPrintf(wxT("Variant %d:%d selected\n"), N, select_variant[N]);
}// OnVariantSelect()

//**********************************************************************
//**********************************************************************
// обработка событий обновления формы

//----------------------------------------------------------------------
// для кнопки ОК
void MyFrame::OnUpdateUIbtnOK(wxUpdateUIEvent& event)
{
	// если выбрана первая раскладка,
	// то делаем кнопку ОК доступной
	event.Enable( select_layout[0]>0 );
}// OnUpdateUIbtnOK()

//----------------------------------------------------------------------
// для вариантов раскладки
void MyFrame::OnUpdateUIchVariant(wxUpdateUIEvent& event)
{
	// если выбрана раскладка, то делаем доступным
	// список ее вариантов, и наоборот
	int id = event.GetId()-id_chVariant0;
	event.Enable(select_layout[id]>0);
}// OnUpdateUIchVariant()

//**********************************************************************
//**********************************************************************
// вспомогательные методы

//----------------------------------------------------------------------
// получение значений параметров из конфиг файла
void MyFrame::ReadConfig()
{
	wxPrintf(wxT("Loadind configuration...\n"));
	
	wxConfigBase *pConfig = wxConfigBase::Get();

	//------------------------------------------------------------------
	// если версия программы запускается впервые
	wxString ConfigVersion = pConfig->Read(wxT("Version"), wxEmptyString);
	if(ConfigVersion!=wxT(VERSION))
	{
		// если до этого использовалась предыдущая версия
		if(pConfig->Read(wxT("Layout0"), 0l)!=0)
		{
			if(wxMessageBox(_("  Previous version of fskbsetting is detected.\n\n"\
			    "  It is neccesary to clean up all configuration files. "\
			    "You can do it right now or later manualy.\n\n"\
			    "Do you want to clean it now automatically?"),
			    _("Information"),
			    wxYES_NO)==wxYES)
			{
				wxPrintf(wxT("Clean old config.\n"));
				ClearFile(file_LXDE, wxT("[\t ]*setxkbmap[\t ]*-layout.*variant.*option.*"));
				ClearFile(file_OB, wxT("[\t ]*setxkbmap[\t ]*-layout.*variant.*option.*"));
				pConfig->DeleteEntry(wxT("LXDE"));
				pConfig->DeleteEntry(wxT("OB"));
			}
		}
		pConfig->Write(wxT("/Version"), wxT(VERSION));
	}

	//------------------------------------------------------------------
	// собираем имена файлов
	wxGetEnv(wxT("HOME"), &homedir);								// получаем домашнюю директорию юзера
	file_LXDE = homedir+wxT("/.config/lxsession/LXDE/autostart");	// и добавляем к полученному пути имена файлов
	file_OB = homedir+wxT("/.config/openbox/autostart.sh");			//
	file_autostart = pConfig->Read(wxT("BootFile"), homedir+wxT("/.config/autostart/fskbset.desktop"));
	
	chModel->SetSelection(pConfig->Read(wxT("Model"), 0l));
	chHotKey->SetSelection(pConfig->Read(wxT("HotKey"), 0l));

	// считываем из конфига выбранные раскладки
	select_layout[0] = pConfig->Read(wxT("Layout0"), 1l);
	select_layout[1] = pConfig->Read(wxT("Layout1"), 0l);
	select_layout[2] = pConfig->Read(wxT("Layout2"), 0l);
	select_layout[3] = pConfig->Read(wxT("Layout3"), 0l);

	// устанавливаем списки раскладок на значения считанные из конфига
	chLayout[0]->SetSelection(select_layout[0]);
	chLayout[1]->SetSelection(select_layout[1]);
	chLayout[2]->SetSelection(select_layout[2]);
	chLayout[3]->SetSelection(select_layout[3]);

	// если выбрана 1, 2, 3, или 4 раскладка,
	// то подгружаем для нее список вариантов
	if(select_layout[0]>0) LoadVariants(0, select_layout[0]);
	if(select_layout[1]>0) LoadVariants(1, select_layout[1]);
	if(select_layout[2]>0) LoadVariants(2, select_layout[2]);
	if(select_layout[3]>0) LoadVariants(3, select_layout[3]);

	// считываем из конфига номера выбранных вариантов
	select_variant[0] = pConfig->Read(wxT("Variant0"), 0l);
	select_variant[1] = pConfig->Read(wxT("Variant1"), 0l);
	select_variant[2] = pConfig->Read(wxT("Variant2"), 0l);
	select_variant[3] = pConfig->Read(wxT("Variant3"), 0l);

	// устанавливаем списки вариантов на значения считанные из конфига
	chVariant[0]->SetSelection(select_variant[0]);
	chVariant[1]->SetSelection(select_variant[1]);
	chVariant[2]->SetSelection(select_variant[2]);
	chVariant[3]->SetSelection(select_variant[3]);

	// считываем и устанавливаем значения чекбокса (автозагрузка)
	chkBoot->SetValue(pConfig->Read(wxT("Boot"), true));
	
	wxPrintf(wxT("Configuration loaded\n"));
}// ReadConfig()

//----------------------------------------------------------------------
// получение моделей клавиатур
void MyFrame::InitModels()
{
	wxPrintf(wxT("Loadind models list...\t\t\t"));
	chModel->Append(_("Auto"));
	Models.Add(wxT(""));

	wxXmlDocument doc;
	doc.Load(xmlBaseFile, wxT("UTF-8"));
	
	wxXmlNode *level_1 = doc.GetRoot()->GetChildren();
	wxXmlNode *level_2;
	wxXmlNode *level_3;
	wxXmlNode *level_4;

	while(level_1) 
	{
		if(level_1->GetName() == wxT("modelList")) 
		{
			level_2 = level_1->GetChildren();
			while(level_2)
			{
				level_3 = level_2->GetChildren();
				while(level_3)
				{
					level_4 = level_3->GetChildren();
					while(level_4)
					{
						if(level_4->GetName() == wxT("name"))
						{
							// добавляем названия клавиатур в массив Models
							wxString value = level_4->GetNodeContent();
							Models.Add(value);
						}
						else if(level_4->GetName() == wxT("description"))
						{
							// добавляем описания клавиатур в выпадающий список
							wxString value = level_4->GetNodeContent();
							chModel->Append((value.Len()<50)?(value):(value.Left(50)+wxT("..."))); // длинные описания клавиатур обрезаем
						}
						level_4 = level_4->GetNext();
					}
					level_3 = level_3->GetNext();
				}
				level_2 = level_2->GetNext();
			}
		}
		level_1 = level_1->GetNext();
	}
	wxPrintf(wxT("Done\n"));
}// InitModels ()

//----------------------------------------------------------------------
// получение раскладок клавиатур
void MyFrame::InitLayouts()
{
	wxPrintf(wxT("Loadind layouts list...\t\t\t"));
	chLayout[0]->Append(_("No"));
	chLayout[1]->Append(_("No"));
	chLayout[2]->Append(_("No"));
	chLayout[3]->Append(_("No"));
	Layouts.Add(wxT(""));

	wxXmlDocument doc;
	doc.Load(xmlBaseFile, wxT("UTF-8"));
	
	wxXmlNode *level_1 = doc.GetRoot()->GetChildren();
	wxXmlNode *level_2;
	wxXmlNode *level_3;
	wxXmlNode *level_4;

	while(level_1) 
	{
		if(level_1->GetName() == wxT("layoutList")) 
		{
			level_2 = level_1->GetChildren();
			while (level_2)
			{
				level_3 = level_2->GetChildren();
				while(level_3)
				{
					level_4 = level_3->GetChildren();
					while(level_4)
					{
						if(level_4->GetName() == wxT("name"))
						{
							wxString value = level_4->GetNodeContent();
							Layouts.Add(value);
						}
						else if(level_4->GetName() == wxT("description"))
						{
							wxString value = level_4->GetNodeContent();
							chLayout[0]->Append(value);
							chLayout[1]->Append(value);
							chLayout[2]->Append(value);
							chLayout[3]->Append(value);
						}
						level_4 = level_4->GetNext();
					}
					level_3 = level_3->GetNext();
				}
				level_2 = level_2->GetNext();
			}
		}
		level_1 = level_1->GetNext();
	}
	wxPrintf(wxT("Done\n"));
} //initLayouts()

//----------------------------------------------------------------------
// загрузка вариантов раскладки
void MyFrame::LoadVariants(int N, int select)
{
	// сначала очищаем список и массив вариантов от старых значений
	chVariant[N]->Clear();
	Variants[N].Clear();
	
	// если выбран вариант 0 (По-умолчанию), то выходим из функции
	if(select==0) return;

	wxPrintf(wxT("Loading variants to %d:%d layout...\t"), N, select);

	chVariant[N]->Append(_("Default"));
	Variants[N].Add( wxT("") );
	
	wxString Layout = wxEmptyString;
	wxString SelectLayout = Layouts.Item(select);
	wxXmlDocument doc;
	doc.Load(xmlBaseFile, wxT("UTF-8"));	   
	wxXmlNode *level_1 = doc.GetRoot()->GetChildren();
	wxXmlNode *level_2;
	wxXmlNode *level_3;
	wxXmlNode *level_4;
	wxXmlNode *level_5;
	wxXmlNode *level_6;

	while(level_1)
	{
		if(level_1->GetName() == wxT("layoutList")) // <layoutList>
		{
			level_2 = level_1->GetChildren(); // <layout>
			while(level_2)
			{
				level_3 = level_2->GetChildren(); //  <configItem> <variantList>
				while(level_3)
				{
					if(level_3->GetName() == wxT("configItem"))
					{
						level_4 = level_3->GetChildren(); //  <name> <description>
						while(level_4)
						{
							if(level_4->GetName() == wxT("name"))
							{
								Layout = level_4->GetNodeContent();
							}
							level_4 = level_4->GetNext();
						}
					}
					else if(level_3->GetName() == wxT("variantList"))
					{	
						if(Layout == SelectLayout)
						{
							level_4 = level_3->GetChildren(); //  <variant>
							while(level_4)
							{
								level_5 = level_4->GetChildren(); //  <configItem>
								while (level_5)
								{
									level_6 = level_5->GetChildren(); //  <name> <description>
									while(level_6)
									{
										if(level_6->GetName() == wxT("name"))
										{
											wxString value = level_6->GetNodeContent();
											Variants[N].Add( value );
										}
										else if(level_6->GetName() == wxT("description"))
										{
											wxString value = level_6->GetNodeContent();
											chVariant[N]->Append(value);
										}
										level_6 = level_6->GetNext();
									}
									level_5 = level_5->GetNext();
								}	
								level_4 = level_4->GetNext();
							}
						}
					}
					level_3 = level_3->GetNext();
				}
				level_2 = level_2->GetNext();
			}
		}
		level_1 = level_1->GetNext();
	}

	// устанавливаем текущее значение для новой раскладки в 0
	chVariant[N]->SetSelection(0);
	select_variant[N] = 0;
	wxPrintf(wxT("Done\n"));
}

//----------------------------------------------------------------------
// загрузка хоткеев
void MyFrame::InitHotKeys()
{
	// СДЕЛАТЬ:
	// 1) чтобы список хоткеев подгружался из base.xml, а не вручную как сейчас.
	// 2) локализацию названий хоткеев полученных из base.xml
	
	wxPrintf(wxT("Loading hotkeys list...\t\t\t"));
	HotKeys.Add(wxT("grp:alt_shift_toggle"));	chHotKey->Append(_("Alt + Shift"));
	HotKeys.Add(wxT("grp:ctrl_shift_toggle"));	chHotKey->Append(_("Ctrl + Shift"));
	HotKeys.Add(wxT("grp:ralt_toggle"));		chHotKey->Append(_("Right Alt"));
	HotKeys.Add(wxT("grp:rctrl_toggle"));		chHotKey->Append(_("Right Ctrl"));
	HotKeys.Add(wxT("grp:rwin_toggle"));		chHotKey->Append(_("Right Win"));
	HotKeys.Add(wxT("grp:lalt_toggle"));		chHotKey->Append(_("Left Alt"));
	HotKeys.Add(wxT("grp:lctrl_toggle"));		chHotKey->Append(_("Left Ctrl"));
	HotKeys.Add(wxT("grp:lwin_toggle"));		chHotKey->Append(_("Left Win"));
	HotKeys.Add(wxT("grp:caps_toggle"));		chHotKey->Append(_("Caps Lock"));
	HotKeys.Add(wxT("grp:menu_toggle"));		chHotKey->Append(_("Menu"));
	wxPrintf(wxT("Done\n"));
}
