/*
 * myframe.h
 * Copyright (C) FSnow 2009-2010 <fsnow@yandex.ru>
 *
	myframe.h is free software: you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the
	Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.
	
	myframe.h is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	See the GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License along
	with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef MYFRAME_H
#define MYFRAME_H

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <wx/frame.h>
#include <wx/intl.h>
#include <wx/sizer.h>
#include <wx/stattext.h>
#include <wx/choice.h>
#include <wx/checkbox.h>
#include <wx/config.h>
#include <wx/statline.h>
#include <wx/artprov.h>
#include <wx/aboutdlg.h>
#include <wx/xml/xml.h>
#include <wx/bmpbuttn.h>
#include <wx/msgdlg.h>
#include "globalvars.h"
#include "rwfile.h"
#include "res/sample.xpm" // иконка
#include <wx/textfile.h>
#include <wx/string.h>
#include <wx/utils.h>

//**********************************************************************
//**********************************************************************
// перечисление идентификаторов элементов окна
enum
{
	id_chModel = wxID_HIGHEST + 1,

	id_chLayout0,
	id_chLayout1,
	id_chLayout2,
	id_chLayout3,

	id_chVariant0,
	id_chVariant1,
	id_chVariant2,
	id_chVariant3,

	id_chkBoot,
	
	id_chHotKey,
	id_btnAbout
};

//**********************************************************************
//**********************************************************************
// класс окна
class MyFrame : public wxFrame
{
	public:
		MyFrame();
		void OnOK(wxCommandEvent& event);
		void OnQuit(wxCommandEvent& event);
		void OnAbout(wxCommandEvent& event);
		void OnUpdateUIchVariant(wxUpdateUIEvent& event);
		void OnUpdateUIbtnOK(wxUpdateUIEvent& event);
		void OnLayoutSelect(wxCommandEvent& event);
		void OnVariantSelect(wxCommandEvent& event);
		void InitModels();
		void InitLayouts();
		void InitHotKeys();
		void ReadConfig();
		void LoadVariants(int, int);
	private:
		wxChoice *chModel;
		wxChoice *chHotKey;
		wxChoice *chLayout[4];
		wxChoice *chVariant[4];
		wxCheckBox *chkBoot;
		wxString homedir;
		wxString file_LXDE;
		wxString file_OB;
		wxString file_autostart;
		
		DECLARE_EVENT_TABLE()
};

#endif //MYFRAME_H
